unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, Buttons,ShellAPI;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    Edit1: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    Label5: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure Memo1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Edit3KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  errorcode:=0;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
  str:string;
begin
  str:=Socket.ReceiveText;
  Memo1.Lines.Add(str);
  label4.Caption:='RX Data : '+inttostr(length(str));

end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
 if(memo1.lines.Count >=300) then memo1.Lines.Clear;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  f:textfile;
begin
   AssignFile(f,'Toybrains_com_cport.dll');
   Rewrite(f);
   writeln(f,edit2.text); // port
   writeln(f,edit1.text);  // ip
   closefile(f);
   ClientSocket1.close;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  ShellExecute(HWnd_Desktop, 'Open', 'www.coreness.com', nil, nil,sw_ShowNormal );
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  f:textfile;
  str:string;
  SearchRec: TSearchRec;
begin
 if FindFirst(ExpandFileName('Toybrains_com_cport.dll'), faAnyFile, SearchRec) = 0 then begin
   AssignFile(f,'Toybrains_com_cport.dll');
   Reset(f);
   Readln(f,str);
   edit2.Text:=inttostr(strtointdef(str,1024));
   Readln(f,str);
   edit1.Text:=str;
   closefile(f);
 end
 else begin
   edit1.Text:='192.168.1.3';
   edit2.Text:='1024';
 end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
   ClientSocket1.Address:=edit1.Text;
   ClientSocket1.Port:=strtointdef(edit2.Text,0);
   ClientSocket1.active:=true;
   label5.Caption:='Status: Connected';
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
   ClientSocket1.active:=false;
   label5.Caption:='Status: DisConnected';
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
    ClientSocket1.Socket.SendText(edit3.text);
    edit3.Clear;
end;

procedure TForm1.Edit3KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if(Key=13) then SpeedButton4Click(Sender);
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
   label3.Caption:='TX Data : '+inttostr(length(edit3.Text));
end;

end.
