unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, Buttons, ExtCtrls, OleCtrls, SHDocVw, ShellAPI,
  ComCtrls,winsock;

type
  TForm1 = class(TForm)
    ServerSocket1: TServerSocket;
    Memo1: TMemo;
    Memo2: TMemo;
    ListBox1: TListBox;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    SpeedButton3: TSpeedButton;
    Animate1: TAnimate;
    Edit2: TEdit;
    Label9: TLabel;
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Memo1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit2Change(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
      procedure ClientList;
      function  GetLocalIP: string;
  end;

var
  Form1: TForm1;
  clientcount_old:integer;
  clientLinkNum:integer;
  anicount:integer;
  Port:string;
implementation

{$R *.DFM}

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  str:string;
begin
  str:=Socket.ReceiveText;
  Memo1.Lines.Add(str);
  label8.Caption:='RX Data: '+inttostr(length(str));

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   ServerSocket1.Port:=strtointdef(edit1.Text,0);
   serverSocket1.active:=true;
   label2.Font.Color:=clred;
   label2.Caption:='Sever ON';
   timer1.Enabled:=true;
   Animate1.Active:=true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
   serverSocket1.active:=false;
   label2.Font.Color:=clblack;
   label2.Caption:='Sever OFF';
   timer1.Enabled:=false;
   Animate1.Active:=false;

end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   memo1.lines.add('conneted '+Socket.RemoteAddress);
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   memo1.lines.add('disconneted '+Socket.RemoteAddress);
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
   if memo1.Lines.Count>=400 then memo1.Clear;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
   label4.Caption:='Select Client: '+listbox1.Items[ListBox1.ItemIndex];
end;

procedure TForm1.ClientList;
var
  i:integer;
begin
   listbox1.Clear;
   for i:= 1 to ServerSocket1.Socket.ActiveConnections do begin
     listbox1.Items.Add(ServerSocket1.Socket.Connections[i-1].RemoteAddress);
   end;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
  i:integer;
begin
   label3.Caption:='Client Count: '+inttostr(ServerSocket1.Socket.ActiveConnections);
   if clientcount_old<>ServerSocket1.Socket.ActiveConnections then ClientList;
   clientcount_old:=ServerSocket1.Socket.ActiveConnections;
   label9.Caption:=format('Local IP %s : %d',[GetLocalIP,strtointdef(edit1.Text,0)]);
   ClientLinkNum:=-1;
  if ListBox1.ItemIndex >=0 then begin
   label4.Caption:='Select Client: '+listbox1.Items[ListBox1.ItemIndex];
   for i:= 1 to ServerSocket1.Socket.ActiveConnections do begin
     if ServerSocket1.Socket.Connections[i-1].RemoteAddress=listbox1.Items[ListBox1.ItemIndex] then begin
        label4.Caption:='Select Client: '+listbox1.Items[ListBox1.ItemIndex]+' -> Link Num: '+inttostr(i-1);
        ClientLinkNum:=i-1;
        break;
     end;
   end;
  end;

end;

function TForm1.GetLocalIP: string;
type
 TaPInAddr = array [0..10] of PInAddr;
 PaPInAddr = ^TaPInAddr;
var
 phe: PHostEnt;  // HostEntry ü
 pptr: PaPInAddr;
 Buffer: array [0..MAX_PATH] of char;
 i: Integer;
 LocalIP: String;
begin
 LocalIP := '';
 GetHostName(Buffer, SizeOf(Buffer));
 phe := GetHostByName(buffer);
 if phe = nil then
 begin
   LocalIP := '127.0.0.1';
   System.Exit;
 end;

 pptr := PaPInAddr(Phe^.h_addr_list);
 i := 0;
 while pptr^[i] <> nil do
 begin
   LocalIP := StrPas(inet_ntoa(pptr^[i]^));
   Inc(i);
 end;
 result:=LocalIP;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  f:textfile;
  str:string;
  SearchRec: TSearchRec;
begin
 ClientLinkNum:=-1;
 anicount:=0;
 if FindFirst(ExpandFileName('Toybrains_com_sport.dll'), faAnyFile, SearchRec) = 0 then begin
   AssignFile(f,'Toybrains_com_sport.dll');
   Reset(f);
   Readln(f,str);
   edit1.Text:=inttostr(strtointdef(str,1024));
   closefile(f);
 end
 else begin
   edit1.Text:='1024';
 end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  ShellExecute(HWnd_Desktop, 'Open', 'www.coreness.com', nil, nil,sw_ShowNormal );
end;

procedure TForm1.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if(Key=13) then begin
   if ClientLinkNum >-1 then begin
      ServerSocket1.Socket.Connections[ClientLinkNum].SendText(edit2.text);
      memo2.lines.add(edit2.Text);
      label5.Font.Color:=clblue;
      label5.Caption:='TCP-TX : '+'OK';
      edit2.Clear;
   end
   else begin
      label5.Font.Color:=clred;
      label5.Caption:='TCP-TX : '+'Not Client Selected';
   end;
 end;

end;

procedure TForm1.Memo2Change(Sender: TObject);
begin
   if memo2.Lines.Count>=400 then memo2.Clear;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  SpeedButton2Click(Sender);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  SearchRec: TSearchRec;
  f:textfile;
begin
   AssignFile(f,'Toybrains_com_sport.dll');
   Rewrite(f);
   writeln(f,edit1.text);
   closefile(f);
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
 label7.Caption:='TX Data: '+inttostr(length(edit2.text));
end;

end.
